<template>
  <div id="profile">
    <div id="editProfile">
      <h1>Edit your profile here</h1>
      <b-container fluid id="parent">
        <div>
          <label for="input-default">Email :</label>
          <b-form-input
            id="input-default"
            type="email"
            :placeholder="this.info.email"
            v-model="email"
          ></b-form-input>
        </div>
        <div>
          <label for="input-default">Username :</label>
          <b-form-input
            id="input-default"
            type="email"
            :placeholder="this.info.username"
            v-model="username"
          ></b-form-input>
        </div>
        <div>
          <label for="input-default">Password :</label>
          <b-form-input
            id="input-default"
            type="password"
            placeholder="Change your password"
            v-model="password"
          ></b-form-input>
        </div> </b-container
      ><br />
      <b-button variant="success" @click="editWorks()"> Edit profile </b-button>
    </div>
  </div>
</template>

<script>
// import Vue from "vue";
import axios from "axios";
import { getUserId } from "@/router/auth.js";
import config from "@/Utils/config.json";

export default {
  name: "Profile",
  data() {
    return {
      info: {},
      email: "",
      username: "",
      password: ""
    };
  },
  methods: {
    async editWorks () {
        const updatedUser = {};
        if (this.email) updatedUser.email = this.email 
        if (this.username) updatedUser.username = this.username 
        if (this.paswword) updatedUser.password = this.password 

        await axios.put(
        `${config.config.res_endpoint}api/users/${getUserId()}`,
        {
          user: updatedUser
        },
        {
          headers: {
            Authorization: "Bearer " + localStorage.getItem("accesToken"),
          },
        }
      );
      await axios
        .get(`${config.config.res_endpoint}api/users/${getUserId()}`, {
          headers: {
            Authorization: "Bearer " + localStorage.getItem("accesToken"),
          },
        })
        .then(
          (response) => (this.info = response.data)
        );
        this.email = ""
        this.username = ""
        this.password = ""
    }
  },
  mounted() {
    axios
      .get(`${config.config.res_endpoint}api/users/${getUserId()}`, {
        headers: {
          Authorization: "Bearer " + localStorage.getItem("accesToken"),
        },
      })
      .then((response) => {
        this.info = response.data;
      });
  },
};
</script>

<style scoped>
#profile {
  display: flex;
  justify-content: space-around;
}

#editProfile {
  width: 50%;
  align-content: center;
  text-align: center;
}
</style>